#import "SoftShadows.h"
#import "SoftShadowsUI.h"


@implementation SoftShadows : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8 {
	return 1;
}

+(BOOL)isSafe {
	return YES;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8 {
	return YES;
}

+ (int)timeModeWithIdentifier:(id)fp8 {
	return 1;
}


+ (Class)inspectorClassWithIdentifier:(id)fp8 {
	return [SoftShadowsUI class];
}

- (id)initWithIdentifier:(id)fp8 {
	
	self = [super initWithIdentifier:fp8];
	if(self) {
		[inputFieldOfView setDoubleValue: 90.0];
	}
	return self;
}


- (id)setup:(QCOpenGLContext *)context {
	return context;
}


- (void)cleanup:(QCOpenGLContext *)context{


}


- (void)enable:(QCOpenGLContext *)context {

}

- (void)disable:(QCOpenGLContext *)context {


}

- (id)attributes
{
	NSMutableDictionary *at = [[[super attributes] mutableCopy] autorelease];
	[at setObject:@"Soft Shadows" forKey:@"name"];
	return at;
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	// CGLContextObj cgl_ctx = [context CGLContextObj];
	
	GLenum error;
	
	double fovy = [inputFieldOfView doubleValue];
	double aspect;
	
	if(fovy < 0.5)
		fovy = 0.5;
	else if(fovy > 180.)
		fovy = 180.;
	
	double theta = fovy * M_PI / 180.0;
	
	double f = 1.0 / tan(theta/2);
	double modifiedMatrix[16];

	GLint oldMatrixMode;
	glGetIntegerv(GL_MATRIX_MODE,&oldMatrixMode);
	glGetDoublev(GL_MODELVIEW_MATRIX, modifiedMatrix);
	
	// Execute subpatches
	glMatrixMode(GL_MODELVIEW);
	// don't push/pop the projection matrix;  it breaks for some reason ( ?? )
	glPushMatrix();
	aspect = modifiedMatrix[5] / modifiedMatrix[0];	// use current aspect ratio.  Derived from f/aspect (om[0]) and f (om[5])
	modifiedMatrix[0] *= f / aspect;
	modifiedMatrix[5] *= f;
	glLoadMatrixd(modifiedMatrix);
	
	[self executeSubpatches:time arguments:arguments];
	
	glPopMatrix();
	glMatrixMode(oldMatrixMode);

	if(error = glGetError())
        [context logMessage:@"OpenGL error %04X", error];

    return (error ? NO : YES);
	
}

@end
